import com.gregor.jrobin.xml.Area;
import com.gregor.jrobin.xml.Datasources;
import com.gregor.jrobin.xml.Def;
import com.gregor.jrobin.xml.Default_font;
import com.gregor.jrobin.xml.Font;
import com.gregor.jrobin.xml.Graph;
import com.gregor.jrobin.xml.Graph_element;
import com.gregor.jrobin.xml.Gprint;
import com.gregor.jrobin.xml.Line;
import com.gregor.jrobin.xml.Options;
import com.gregor.jrobin.xml.Rrd_graph_def;
import com.gregor.jrobin.xml.Span;
import com.gregor.jrobin.xml.Stack;
import com.gregor.jrobin.xml.Rrd_graph_def;
import com.gregor.jrobin.xml.Title_font;

import com.gregor.jrobin.xml.types.Cf;
import com.gregor.jrobin.xml.types.FontStyle;

import com.gregor.rrd.RRDJRobin;
import com.gregor.rrd.RrdGraphDefPublic;
import com.gregor.rrd.RrdGraphPlot;
import com.gregor.util.TextUtils;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.FileWriter;

import java.util.Map;
import java.util.LinkedHashMap;
import java.util.Properties;

import org.jrobin.graph.RrdGraphDef;

import org.opennms.core.utils.BundleLists;

import org.opennms.web.graph.PrefabGraph;


public class javatest {
	public static void main(String[] argv) throws Exception {
	    //		Rrd_graph_def.unmarshal(new FileReader("/Users/dgregor/test.xml"));

	    //		System.exit(0);

		System.setProperty("java.awt.headless", "true");
		System.setProperty("org.exolab.castor.indent", "true");

		RRDJRobin rrd = new RRDJRobin();

		String propertiesFilename = "/Users/dgregor/opennms/HEAD/opennms/etc/snmp-graph.properties";
//		String propertiesFilename = "/Users/dgregor/opennms/OPENNMS_1_2_BRANCH/opennms/etc/snmp-graph.properties";
		String listKey = "reports";

		Properties properties = new Properties();
		properties.load(new FileInputStream(propertiesFilename));

//		Map map = PrefabGraph.getPrefabGraphDefinitions(properties);

        	Map map = new LinkedHashMap();

		String listString = (String) properties.get(listKey);

		String[] list = BundleLists.parseBundleList(listString);

		for (int i = 0; i < list.length; i++) {
			String key = list[i];
			PrefabGraph graph = new PrefabGraph(key, properties, i);

			map.put(key, graph);

			Rrd_graph_def def = new Rrd_graph_def();
			def.setOptions(new Options());
			def.setSpan(new Span());
			def.setDatasources(new Datasources());
			def.setGraph(new Graph());

			String[] commandArray =
			    RRDJRobin.tokenize(graph.getCommand().trim(), " \t",
					       true);
	
			RRDJRobin.OptionBean bean = new RRDJRobin.OptionBean();
			RrdGraphDefPublic graphDef;
			try {
			    graphDef = rrd.parseGraphCommand(commandArray,
							new File(""), bean);
			} catch (Exception e) {
				System.err.println("failed command: \"" +
						   TextUtils.join("\", \"",
						   commandArray) + "\"");
				throw e;
			}

			def.getOptions().setTitle(graphDef.getTitleP());

			Default_font defaultFont = new Default_font();
			defaultFont.setName(graphDef.getDefaultFont().getFontName().replaceFirst("\\.plain$", ""));
			defaultFont.setSize(graphDef.getDefaultFont().getSize());
			int s = graphDef.getDefaultFont().getStyle();
			if (s == java.awt.Font.PLAIN) {
			    defaultFont.setStyle(FontStyle.PLAIN);
			} else if (s ==
				   (java.awt.Font.BOLD + java.awt.Font.ITALIC)){
			    defaultFont.setStyle(FontStyle.BOLD_ITALIC);
			} else if (s == java.awt.Font.BOLD) {
			    defaultFont.setStyle(FontStyle.BOLD);
			} else if (s == java.awt.Font.ITALIC) {
			    defaultFont.setStyle(FontStyle.ITALIC);
			} else {
			    throw new Exception("Unknown font style: " + s);
			}

			def.getOptions().setDefault_font(defaultFont);


			Title_font titleFont = new Title_font();
			titleFont.setName(graphDef.getTitleFont().getFontName().replaceFirst("\\.plain$", ""));
			titleFont.setSize(graphDef.getTitleFont().getSize());
			s = graphDef.getTitleFont().getStyle();
			if (s == java.awt.Font.PLAIN) {
			    titleFont.setStyle(FontStyle.PLAIN);
			} else if (s ==
				   (java.awt.Font.BOLD + java.awt.Font.ITALIC)){
			    titleFont.setStyle(FontStyle.BOLD_ITALIC);
			} else if (s == java.awt.Font.BOLD) {
			    titleFont.setStyle(FontStyle.BOLD);
			} else if (s == java.awt.Font.ITALIC) {
			    titleFont.setStyle(FontStyle.ITALIC);
			} else {
			    throw new Exception("Unknown font style: " + s);
			}

			def.getOptions().setTitle_font(titleFont);

			String[][] defs = graphDef.getDefsP();
			for (int j = 0; j < defs.length; j++) {
			    Def d = new Def();
			    d.setName(defs[j][0]);
			    //d.setRrd(defs[j][1].substring(1));
			    d.setSource(defs[j][2]);
			    d.setCf(Cf.valueOf(defs[j][3]));
			    def.getDatasources().addDef(d);
			}

			String[][] cdefs = graphDef.getCdefsP();
			for (int j = 0; j < cdefs.length; j++) {
			    Def d = new Def();
			    d.setName(cdefs[j][0]);
			    d.setRpn(cdefs[j][1]);
			    def.getDatasources().addDef(d);
			}

			RrdGraphPlot[] plotDefs = graphDef.getPlotDefsP();
			for (int j = 0; j < plotDefs.length; j++) {
			    String color = "#" + Integer.toHexString(plotDefs[j].getColor().getRGB()).substring(2);
			    Graph_element e = new Graph_element();
			    if (plotDefs[j].getLineWidth() == RrdGraphPlot.LINE_SIZE_AREA) {
				Area d = new Area();
				d.setDatasource(plotDefs[j].getSourceName());
				d.setColor(color);
				d.setLegend(plotDefs[j].getLegend());
				e.setArea(d);
			    } else if (plotDefs[j].getLineWidth() == RrdGraphPlot.LINE_SIZE_STACK) {
				Stack d = new Stack();
				d.setDatasource(plotDefs[j].getSourceName());
				d.setColor(color);
				d.setLegend(plotDefs[j].getLegend());
				e.setStack(d);
			    } else {
				Line d = new Line();
				d.setDatasource(plotDefs[j].getSourceName());
				d.setColor(color);
				d.setLegend(plotDefs[j].getLegend());
				d.setWidth(plotDefs[j].getLineWidth());
				e.setLine(d);
			    }
			    def.getGraph().addGraph_element(e);
			}

			String[][] gprints = graphDef.getGprints();
			for (int j = 0; j < gprints.length; j++) {
			    Gprint d = new Gprint();
			    d.setDatasource(gprints[j][0]);
			    d.setCf(Cf.valueOf(gprints[j][1]));
			    d.setFormat(gprints[j][2].replaceFirst("\\n$", "@l"));
			    Graph_element e = new Graph_element();
			    e.setGprint(d);
			    def.getGraph().addGraph_element(e);
			}

			String[] comments = graphDef.getCommentsP();
			for (int j = 0; j < comments.length; j++) {
			    Graph_element e = new Graph_element();
			    e.setComment(comments[j].replaceFirst("\\n$", "@l"));

			    def.getGraph().addGraph_element(e);
			}

			FileWriter w = new FileWriter("work/output/" + key + ".xml");
			def.marshal(w);
			w.close();
		}
	}


}
